<?php
//
//  入力データのチェック
//  戻り値：list(ページ番号, 検索方法のチェック状況[], エラーメッセージ)
//
function    zip_check()
{
    if (DEBUG)  { 
        print "zip_check()<br>\n";
        print "\$_GET[] = "; print_r($_GET); print "<br>\n";
        print "\$_SESSION[] = "; print_r($_SESSION); print "<br>\n";
    }
    //
    //  セッションデータの取り出し
    //
    $page = 0;      //  ページ番号
    if (isset($_GET['page']) && isset($_SESSION['count']))  {
        $_POST['type']   = $_SESSION['type'];
        $_POST['zip7']   = $_SESSION['zip7'];
        $_POST['pref_j'] = $_SESSION['pref_j'];
        $_POST['city_j'] = $_SESSION['city_j'];
        $_POST['count']  = $_SESSION['count'];
        if (preg_match("/^[0-9]+$/", $_GET['page']) > 0) {
            $page = $_GET['page'];
        }
    }
    //
    //  特殊文字をHTMLエンティティに変換する
    //
    foreach ($_POST as $key => $value)  {
        $_POST[$key] = htmlspecialchars($value);
    }
    foreach ($_GET as $key => $value)  {
        $_GET[$key] = htmlspecialchars($value);
    }
    if (DEBUG)  {
        print "\$_POST[] = "; print_r($_POST); print "<br>\n";
    }
    $sel = array();                 //  配列変数として初期化
    $error = '';
    if (!isset($_POST['type'])) {
        $_POST['type'] = '';
    }
    switch  ($_POST['type'])  {
    case    '1':    //  郵便番号で検索
        $sel[1]="checked";
        if (isset($_POST['button']) && 
            preg_match("/^[0-9]+$/", $_POST['zip7']) == 0)    {
            $error='<font color="red">郵便番号エラー</font>';
        }
        break;
    case    '2':    //  住所で検索
        $sel[2]="checked";
        if (isset($_POST['button']) && 
            strlen($_POST['pref_j']) == 0 && strlen($_POST['city_j']) == 0) {
            $error='<font color="red">'
                . "都道府県か市区町村のいずれかを入力してください。</font>";
        }
        break;
    default:
        if (isset($_POST['button']))    {
            $error='<font color="red">検索方法を選択してください。</font>';
        } else  {
            $sel[1]="checked";      //  デフォルト値
            $error = "";            //  初期状態はエラー
        }
    }
    return  array($page, $sel, $error);
}   //  zip_check()
